function inside = D_gnep(States) 
    %----------------------------------------------------------------------
    % Description: Jump set
    % Return 0 if outside of D, and 1 if inside D
    %----------------------------------------------------------------------

    global param;
    
    g           = param{4}; %vector of functions of convex constraints g(x)<= 0
    k_limit     = param{6}; %min and max values of the dual koeficients
    i           = param{8}; %indices used in iterations
    epsilon     = param{9}; %parameter used for creating histeresis
    
    u       = States(i(1) + 1 : i(2));
    k       = States(i(5) + 1 : i(6));
    s       = States(i(6) + 1 : i(7));
    
    g_eval  = g(u);
    
    change_index = (g_eval >= 2 * epsilon & s == 0) | ...
        (g_eval <= epsilon & s == 1) | (k >= k_limit(2) & (s == 1 | s == 0));
    
    inside = sum(change_index) >= 1;
    
end