function StatePlus = g(States)

    global param;
    
    i       = param{2};
    T       = param{3}; %vektor perioda
    gamma   = param{4};
    J       = param{5};
    R       = param{6};
    m_i     = param{7};
    A       = param{9};
    beta    = param{10};

    
    x   = States(i(1) + 1 : i(2));
    tau = States(i(2) + 1 : i(3));
    xi  = States(i(3) + 1 : i(4));
    mi  = States(i(4) + 1 : i(5));
    k   = States(i(5) + 1 : i(6));
    
    S                   = tau + 1e-10>= T';
    S_mi                = kron(S, ones(2 * m_i, 1));
    S_x                 = kron(S, ones(m_i, 1));
    
    StatePlus = States;
    
    
    StatePlus(i(1) + 1 : i(2))  = x - gamma * beta * S_x .* xi;
    StatePlus(i(2) + 1 : i(3))  = ~S .* tau;
    StatePlus(i(3) + 1 : i(4))  = xi + gamma * S_x.* (2 * 1./A .* ...
        J(x + A .* mi(1:2:end)).* mi(1:2:end) - xi);
    StatePlus(i(4) + 1 : i(5))  = ~S_mi .* mi + S_mi .* R * mi;
    StatePlus(i(5) + 1 : i(6))  = k + S_x;
   
end