function [x] = proj_box(x, constr)
%% input: x, constr
% constr = [xmin, xmax];

    lower_bound = x < constr(:, 1);
    upper_bound = x > constr(:, 2);
    
    if size(x, 2) == 1
        x(lower_bound) = constr(lower_bound, 1);
        x(upper_bound) = constr(upper_bound, 2);
    else
        mini = repmat(constr(:, 1), size(x, 2));
        maxi = repmat(constr(:, 2), size(x, 2));
        
        x(lower_bound) = mini(lower_bound);
        x(upper_bound) = maxi(upper_bound);
    end
    
end

